Index: less/cmdbuf.c
diff -u less/cmdbuf.c:1.1.1.14 less/cmdbuf.c:1.39
--- less/cmdbuf.c:1.1.1.14	Sun Oct 29 02:03:31 2000
+++ less/cmdbuf.c	Tue Oct 31 04:30:39 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -25,6 +31,11 @@
 static char *cp;		/* Pointer into cmdbuf */
 static int cmd_offset;		/* Index into cmdbuf of first displayed char */
 static int literal;		/* Next input char should not be interpreted */
+static CHARSET cmdcs[CMDBUF_SIZE]; /* Buffer for holding a CHARSET of cmdbuf */
+static CHARSET *csp;		/* Pointer into cmdcs */
+#if ISO
+static MULBUF *mp = NULL;
+#endif
 
 #if TAB_COMPLETE_FILENAME
 static int cmd_complete();
@@ -57,22 +68,23 @@
 	struct mlist *prev;
 	struct mlist *curr_mp;
 	char *string;
+	CHARSET *charset;
 };
 
 /*
  * These are the various command histories that exist.
  */
 struct mlist mlist_search =  
-	{ &mlist_search,  &mlist_search,  &mlist_search,  NULL };
+	{ &mlist_search,  &mlist_search,  &mlist_search,  NULL, NULL };
 public void constant *ml_search = (void *) &mlist_search;
 
 struct mlist mlist_examine = 
-	{ &mlist_examine, &mlist_examine, &mlist_examine, NULL };
+	{ &mlist_examine, &mlist_examine, &mlist_examine, NULL, NULL };
 public void constant *ml_examine = (void *) &mlist_examine;
 
 #if SHELL_ESCAPE || PIPEC
 struct mlist mlist_shell =   
-	{ &mlist_shell,   &mlist_shell,   &mlist_shell,   NULL };
+	{ &mlist_shell,   &mlist_shell,   &mlist_shell,   NULL, NULL };
 public void constant *ml_shell = (void *) &mlist_shell;
 #endif
 
@@ -95,6 +107,25 @@
 
 
 /*
+ * Count the width of strings.
+ */
+	static int
+strwidth(s, cs)
+	char *s;
+	CHARSET cs;
+{
+#if ISO
+	int w = 0;
+
+	while (*s != '\0')
+		w += mwidth(*s++, cs);
+	return (w);
+#else
+	return (strlen(s));
+#endif
+}
+
+/*
  * Reset command buffer (to empty).
  */
 	public void
@@ -102,9 +133,25 @@
 {
 	cp = cmdbuf;
 	*cp = '\0';
+	csp = cmdcs;
+	*csp = NULLCS;
 	cmd_col = 0;
 	cmd_offset = 0;
 	literal = 0;
+#if ISO
+	if (mp == NULL)
+	{
+		char *s = NULL;
+		mp = new_multi();
+		s = getenv("JLESSKEYCHARSET");
+		if (s == NULL)
+			s = DEFKEYCHARSET;
+		set_codesets(mp, left_codeset_of_charset(s),
+			     right_codeset_of_charset(s));
+		init_priority(mp);
+	}
+	init_multi(mp);
+#endif
 }
 
 /*
@@ -125,8 +172,8 @@
 	char *s;
 {
 	putstr(s);
-	cmd_col += strlen(s);
-	prompt_col += strlen(s);
+	cmd_col += strwidth(s, ASCII);
+	prompt_col += strwidth(s, ASCII);
 }
 
 /*
@@ -135,7 +182,7 @@
 	public int
 len_cmdbuf()
 {
-	return (strlen(cmdbuf));
+	return (strlen_cs(cmdbuf, cmdcs));
 }
 
 /*
@@ -152,13 +199,13 @@
 	 * Repaint the line from the current position.
 	 */
 	clear_eol();
-	for ( ;  *cp != '\0';  cp++)
+	for ( ;  *cp != '\0';  cp++, csp++)
 	{
-		p = prchar(*cp);
-		if (cmd_col + strlen(p) >= sc_width)
+		p = prchar(*cp, *csp);
+		if (cmd_col + strwidth(p, *csp) >= sc_width)
 			break;
-		putstr(p);
-		cmd_col += strlen(p);
+		putmchrs(p, *csp);
+		cmd_col += strwidth(p, *csp);
 	}
 
 	/*
@@ -182,6 +229,7 @@
 	}
 
 	cp = &cmdbuf[cmd_offset];
+	csp = &cmdcs[cmd_offset];
 }
 
 /*
@@ -191,6 +239,7 @@
 cmd_lshift()
 {
 	char *s;
+	CHARSET *t;
 	char *save_cp;
 	int cols;
 
@@ -199,9 +248,10 @@
 	 * right we'd have to move to reach the center of the screen.
 	 */
 	s = cmdbuf + cmd_offset;
-	cols = 0;
-	while (cols < (sc_width - prompt_col) / 2 && *s != '\0')
-		cols += strlen(prchar(*s++));
+	t = cmdcs + cmd_offset;
+	for (cols = 0; cols < (sc_width - prompt_col) / 2 && *s != '\0';
+	     s++, t++)
+		cols += strwidth(prchar(*s, *t), *t);
 
 	cmd_offset = s - cmdbuf;
 	save_cp = cp;
@@ -216,6 +266,7 @@
 cmd_rshift()
 {
 	char *s;
+	CHARSET *t;
 	char *p;
 	char *save_cp;
 	int cols;
@@ -226,11 +277,12 @@
 	 * of displayed characters.
 	 */
 	s = cmdbuf + cmd_offset;
+	t = cmdcs + cmd_offset;
 	cols = 0;
 	while (cols < (sc_width - prompt_col) / 2 && s > cmdbuf)
 	{
-		p = prchar(*--s);
-		cols += strlen(p);
+		p = prchar(*--s, *--t);
+		cols += strwidth(p, *t);
 	}
 
 	cmd_offset = s - cmdbuf;
@@ -247,6 +299,9 @@
 {
 	char *p;
 	
+#if ISO
+	do {
+#endif
 	if (*cp == '\0')
 	{
 		/* 
@@ -254,14 +309,18 @@
 		 */
 		return (CC_OK);
 	}
-	p = prchar(*cp);
-	if (cmd_col + strlen(p) >= sc_width)
+	p = prchar(*cp, *csp);
+	if (cmd_col + strwidth(p, *csp) >= sc_width)
 		cmd_lshift();
-	else if (cmd_col + strlen(p) == sc_width - 1 && cp[1] != '\0')
+	else if (cmd_col + strwidth(p, *csp) == sc_width - 1 && cp[1] != '\0')
 		cmd_lshift();
+	putmchrs(p, *csp);
+	cmd_col += strwidth(p, *csp);
 	cp++;
-	putstr(p);
-	cmd_col += strlen(p);
+	csp++;
+#if ISO
+	} while (CSISREST(*csp));
+#endif
 	return (CC_OK);
 }
 
@@ -273,18 +332,25 @@
 {
 	char *p;
 	
+#if ISO
+	do {
+#endif
 	if (cp <= cmdbuf)
 	{
 		/* Already at the beginning of the line */
 		return (CC_OK);
 	}
-	p = prchar(cp[-1]);
-	if (cmd_col < prompt_col + strlen(p))
+	p = prchar(cp[-1], csp[-1]);
+	if (cmd_col < prompt_col + strwidth(p, csp[-1]))
 		cmd_rshift();
 	cp--;
-	cmd_col -= strlen(p);
+	csp--;
+	cmd_col -= strwidth(p, *csp);
 	while (*p++ != '\0')
 		putbs();
+#if ISO
+	} while (CSISREST(*csp));
+#endif
 	return (CC_OK);
 }
 
@@ -296,8 +362,13 @@
 	int c;
 {
 	char *s;
+	CHARSET *t;
 	
-	if (strlen(cmdbuf) >= sizeof(cmdbuf)-2)
+#if ISO
+	if (strlen_cs(cmdbuf, cmdcs) >= (int)sizeof(cmdbuf)-5)
+#else
+	if (strlen_cs(cmdbuf, cmdcs) >= (int)sizeof(cmdbuf)-2)
+#endif
 	{
 		/*
 		 * No room in the command buffer for another char.
@@ -309,9 +380,46 @@
 	/*
 	 * Insert the character into the buffer.
 	 */
-	for (s = &cmdbuf[strlen(cmdbuf)];  s >= cp;  s--)
+#if ISO
+	if (in_mca())
+	{
+		char *cbuf;
+		CHARSET *csbuf;
+		int i, j;
+
+		buffering_multi(mp, c, &cbuf, &csbuf, &i);
+		if (i > 0)
+			for ((s = &cmdbuf[strlen_cs(cmdbuf, cmdcs)]),
+			     t = &cmdcs[strlen_cs(cmdbuf, cmdcs)];
+			     s >= cp;  s--, t--)
+			{
+				s[i] = s[0];
+				t[i] = t[0];
+			}
+		for (j = 0; j < i; j++)
+		{
+			cp[j] = cbuf[j];
+			csp[j] = csbuf[j];
+		}
+		cbuf = &cp[i];
+		/*
+		 * Reprint the tail of the line from the inserted char.
+		 */
+		cmd_repaint(cp);
+		while (cp < cbuf)
+			cmd_right();
+		return (CC_OK);
+	}
+#endif
+	for ((s = &cmdbuf[strlen_cs(cmdbuf, cmdcs)]),
+	     t = &cmdcs[strlen_cs(cmdbuf, cmdcs)];
+	     s >= cp;  s--, t--)
+	{
 		s[1] = s[0];
+		t[1] = t[0];
+	}
 	*cp = c;
+	*csp = ASCII;
 	/*
 	 * Reprint the tail of the line from the inserted char.
 	 */
@@ -328,6 +436,8 @@
 cmd_erase()
 {
 	register char *s;
+	register CHARSET *t;
+	int num;
 
 	if (cp == cmdbuf)
 	{
@@ -340,12 +450,17 @@
 	/*
 	 * Move cursor left (to the char being erased).
 	 */
+	s = cp;
 	cmd_left();
+	num = s - cp;
 	/*
 	 * Remove the char from the buffer (shift the buffer left).
 	 */
-	for (s = cp;  *s != '\0';  s++)
-		s[0] = s[1];
+	for ((s = cp), t = csp;  *s != '\0';  s++, t++)
+	{
+		s[0] = s[num];
+		t[0] = t[num];
+	}
 	/*
 	 * Repaint the buffer after the erased char.
 	 */
@@ -481,6 +596,8 @@
 	int action;
 {
 	char *s;
+	CHARSET *t;
+	int i;
 	
 	if (curr_mlist == NULL)
 	{
@@ -503,14 +620,18 @@
 	 * Copy the entry into cmdbuf and echo it on the screen.
 	 */
 	s = curr_mlist->curr_mp->string;
+	t = curr_mlist->curr_mp->charset;
 	if (s == NULL)
 		s = "";
-	for (cp = cmdbuf;  *s != '\0';  s++)
+	for ((cp = cmdbuf), (csp = cmdcs), i = 0;  *s != '\0';  s++, t++, i++)
 	{
-		*cp = *s;
-		cmd_right();
+		cp[i] = *s;
+		csp[i] = *t;
 	}
-	*cp = '\0';
+	cp[i] = '\0';
+	csp[i] = NULLCS;
+	while (*cp != '\0')
+		cmd_right();
 	return (CC_OK);
 }
 #endif
@@ -519,9 +640,10 @@
  * Add a string to a history list.
  */
 	public void
-cmd_addhist(mlist, cmd)
+cmd_addhist(mlist, cmd, cs)
 	struct mlist *mlist;
 	char *cmd;
+	CHARSET *cs;
 {
 #if CMD_HISTORY
 	struct mlist *ml;
@@ -529,7 +651,7 @@
 	/*
 	 * Don't save a trivial command.
 	 */
-	if (strlen(cmd) == 0)
+	if (strlen_cs(cmd, cs) == 0)
 		return;
 	/*
 	 * Don't save if a duplicate of a command which is already 
@@ -548,7 +670,7 @@
 		 * Save the command and put it at the end of the history list.
 		 */
 		ml = (struct mlist *) ecalloc(1, sizeof(struct mlist));
-		ml->string = save(cmd);
+		ml->string = strdup_cs(cmd, cs, &ml->charset);
 		ml->next = mlist;
 		ml->prev = mlist->prev;
 		mlist->prev->next = ml;
@@ -575,7 +697,7 @@
 	 */
 	if (curr_mlist == NULL)
 		return;
-	cmd_addhist(curr_mlist, cmdbuf);
+	cmd_addhist(curr_mlist, cmdbuf, cmdcs);
 #endif
 }
 
@@ -1019,4 +1141,13 @@
 get_cmdbuf()
 {
 	return (cmdbuf);
+}
+
+/*
+ * Return a pointer to the character set bufffer of the command buffer.
+ */
+	public CHARSET *
+get_cmdcs()
+{
+	return (cmdcs);
 }
Index: less/command.c
diff -u less/command.c:1.1.1.17 less/command.c:1.25
--- less/command.c:1.1.1.17	Sun Oct 29 02:19:09 2000
+++ less/command.c	Tue Oct 31 04:30:39 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -176,15 +182,17 @@
 exec_mca()
 {
 	register char *cbuf;
+	CHARSET *csbuf;
 
 	cmd_exec();
 	cbuf = get_cmdbuf();
+	csbuf = get_cmdcs();
 
 	switch (mca)
 	{
 	case A_F_SEARCH:
 	case A_B_SEARCH:
-		multi_search(cbuf, number);
+		multi_search(cbuf, csbuf, number);
 		break;
 	case A_FIRSTCMD:
 		/*
@@ -726,8 +734,9 @@
  * If SRCH_PAST_EOF is set, continue the search thru multiple files.
  */
 	static void
-multi_search(pattern, n)
+multi_search(pattern, charset, n)
 	char *pattern;
+	CHARSET *charset;
 	int n;
 {
 	register int nomore;
@@ -758,7 +767,7 @@
 
 	for (;;)
 	{
-		n = search(search_type, pattern, n);
+		n = search(search_type, pattern, charset, n);
 		/*
 		 * The SRCH_NO_MOVE flag doesn't "stick": it gets cleared
 		 * after being used once.  This allows "n" to work after
@@ -1210,7 +1219,7 @@
 #define	DO_SEARCH()	if (number <= 0) number = 1;	\
 			mca_search();			\
 			cmd_exec();			\
-			multi_search((char *)NULL, number);
+			multi_search((char *)NULL, (CHARSET *)NULL, number);
 
 
 		case A_F_SEARCH:
@@ -1534,6 +1543,16 @@
 			}
 			c = getcc();
 			goto again;
+
+#if JAPANESE
+		case A_ROT_RCODESET:
+			parg.p_string =
+				rotate_right_codeset(get_mulbuf(curr_ifile));
+			screen_trashed = 1;
+			make_display();
+			error("%s codeset is used in right plane", &parg);
+			break;
+#endif
 
 		case A_NOACTION:
 			break;
Index: less/configure.in
diff -u less/configure.in:1.1.1.14 less/configure.in:1.9
--- less/configure.in:1.1.1.14	Sun Oct 29 02:19:14 2000
+++ less/configure.in	Wed Nov 22 03:43:25 2000
@@ -2,6 +2,13 @@
 AC_INIT(forwback.c)
 AC_CONFIG_HEADER(defines.h)
 
+dnl Checks for arguments.
+AC_ARG_WITH(cs-regex, [  --with-cs-regex         Regular expression library with character set detection], have_regex_cs=$withval, have_regex_cs=no)
+msb_enable=unknown
+AC_ARG_ENABLE(msb, [  --disable-msb           Disable the MSB of non ASCII characters], msb_enable=$enableval)
+jisx0213_enable=unknown
+AC_ARG_ENABLE(jisx0213, [  --disable-jisx0213      Disable the JIS X 0213 mapping for SJIS and UJIS], jisx0213_enable=$enableval)
+
 dnl Checks for programs.
 AC_PROG_CC
 AC_ISC_POSIX
@@ -226,7 +233,23 @@
 fi
 
 dnl Checks for regular expression functions.
+if test $have_regex_cs != no; then
+AC_DEFINE(CS_REGEX)
+dnl try to find it with character set detection.
 have_regex=no
+if test $have_regex = no && test -f ${srcdir}/regex_cs.c; then
+AC_MSG_RESULT(using POSIX regcomp_cs -- local source); AC_DEFINE(HAVE_POSIX_REGCOMP_CS) REGEX_O='regex_cs.$(O)' AC_SUBST(REGEX_O) have_regex=yes
+fi
+if test $have_regex = no && test -f ${srcdir}/regexp_cs.c; then
+AC_MSG_RESULT(using V8 regcomp_cs -- local source); AC_DEFINE(HAVE_V8_REGCOMP_CS) REGEX_O='regexp_cs.$(O)' AC_SUBST(REGEX_O) have_regex=yes
+fi
+if test $have_regex = no; then
+AC_MSG_RESULT(cannot find regular expression library with character set detection); AC_DEFINE(NO_REGEX)
+fi
+else
+AC_DEFINE(CS_REGEX, 0)
+dnl try to find it without character set detection.
+have_regex=no
 have_posix_regex=unknown
 AC_MSG_CHECKING(for regcomp)
 
@@ -306,6 +329,32 @@
 if test $have_regex = no; then
 AC_MSG_RESULT(cannot find regular expression library); AC_DEFINE(NO_REGEX)
 fi
+fi
+
+case $msb_enable in
+yes) AC_MSG_RESULT(enable the MSB of non ASCII characters)
+     AC_DEFINE(MSB_ENABLE);;
+no)  AC_MSG_RESULT(disable the MSB of non ASCII characters)
+     AC_DEFINE(MSB_ENABLE, 0);;
+unknown)
+     if test $have_regex_cs = no; then
+     AC_MSG_RESULT(decide to enable the MSB of non ASCII characters)
+     AC_DEFINE(MSB_ENABLE)
+     else
+     AC_MSG_RESULT(decide to disable the MSB of non ASCII characters)
+     AC_DEFINE(MSB_ENABLE, 0)
+     fi;;
+esac
+
+case $jisx0213_enable in
+unknown|yes)
+     AC_MSG_RESULT(enable the JIS X 0213 mapping for SJIS and UJIS)
+     AC_DEFINE(SJIS0213, 1)
+     AC_DEFINE(UJIS0213, 1);;
+no)  AC_MSG_RESULT(disable the JIS X 0213 mapping for SJIS and UJIS)
+     AC_DEFINE(SJIS0213, 0)
+     AC_DEFINE(UJIS0213, 0);;
+esac
 
 AC_ARG_WITH(editor,
   [  --with-editor=PROGRAM   use PROGRAM as the default editor [vi]],
Index: less/decode.c
diff -u less/decode.c:1.1.1.16 less/decode.c:1.22
--- less/decode.c:1.1.1.16	Sun Oct 29 02:19:10 2000
+++ less/decode.c	Tue Oct 31 04:30:39 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines are reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /*
@@ -150,6 +156,10 @@
 	'v',0,				A_VISUAL,
 	'!',0,				A_SHELL,
 	'+',0,				A_FIRSTCMD,
+
+#if JAPANESE
+	'@',0,				A_ROT_RCODESET,
+#endif
 
 	'H',0,				A_HELP,
 	'h',0,				A_HELP,
Index: less/defines.ds
diff -u less/defines.ds:1.1.1.5 less/defines.ds:1.15
--- less/defines.ds:1.1.1.5	Sun Oct 29 02:19:18 2000
+++ less/defines.ds	Tue Oct 31 04:30:39 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /* DOS definition file for less.  */
@@ -175,6 +181,46 @@
 #define	HAVE_DUP	1
 
 /*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"sjis-iso7"
+
+/*
  * Sizes of various buffers.
  */
 #define	CMDBUF_SIZE	512	/* Buffer for multichar commands */
@@ -200,13 +246,19 @@
 
 /*
  * Regular expression library.
+ * Some are extended to detect character set.
  * Define exactly one of the following to be 1:
+ * HAVE_POSIX_REGCOMP_CS: extended POSIX regcomp() and regex.h
+ * HAVE_V8_REGCOMP_CS: extended Henry Spencer V8 regcomp() and regexp.h
  * HAVE_POSIX_REGCOMP: POSIX regcomp() and regex.h
  * HAVE_RE_COMP: BSD re_comp()
  * HAVE_REGCMP: System V regcmp()
  * HAVE_V8_REGCOMP: Henry Spencer V8 regcomp() and regexp.h
- * NO_REGEX: pattern matching is supported, but without metacharacters.
+ * NO_REGEX: pattern matching with character set detection is supported,
+ *           but without metacharacters.
  */
+/* #undef HAVE_POSIX_REGCOMP_CS */
+/* #undef HAVE_V8_REGCOMP_CS */
 /* #undef HAVE_POSIX_REGCOMP */
 /* #undef HAVE_RE_COMP */
 /* #undef HAVE_REGCMP */
@@ -215,6 +267,27 @@
 #define	HAVE_POSIX_REGCOMP 1
 #else
 #define NO_REGEX 1
+#endif
+
+/*
+ * Does regular expression library detect character set?
+ */
+#if NO_REGEX
+#define CS_REGEX 1
+#else
+#define CS_REGEX 0
+#endif
+
+/*
+ * Define MSB_ENABLE if you want to enable a MSB of non ASCII characters.
+ * It will be help if your library has not ability to detect a character set.
+ * If it has ability, this should be 0.  If your system was not worked well,
+ * try to change following into 0 by hand.
+ */
+#if CS_REGEX
+#define MSB_ENABLE 0
+#else
+#define MSB_ENABLE 1
 #endif
 
 /* Define HAVE_VOID if your compiler supports the "void" type. */
Index: less/defines.h.in
diff -u less/defines.h.in:1.1.1.14 less/defines.h.in:1.33
--- less/defines.h.in:1.1.1.14	Sun Oct 29 02:19:15 2000
+++ less/defines.h.in	Wed Nov 22 03:43:25 2000
@@ -159,6 +159,46 @@
 #define	HAVE_DUP	1
 
 /*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"japanese-iso7"
+
+/*
  * Sizes of various buffers.
  */
 #define	CMDBUF_SIZE	512	/* Buffer for multichar commands */
@@ -186,14 +226,20 @@
 
 /*
  * Regular expression library.
+ * Some are extended to detect character set.
  * Define exactly one of the following to be 1:
+ * HAVE_POSIX_REGCOMP_CS: extended POSIX regcomp() and regex.h
+ * HAVE_V8_REGCOMP_CS: extended Henry Spencer V8 regcomp() and regexp.h
  * HAVE_POSIX_REGCOMP: POSIX regcomp() and regex.h
  * HAVE_PCRE: PCRE (Perl-compatible regular expression) library
  * HAVE_RE_COMP: BSD re_comp()
  * HAVE_REGCMP: System V regcmp()
  * HAVE_V8_REGCOMP: Henry Spencer V8 regcomp() and regexp.h
- * NO_REGEX: pattern matching is supported, but without metacharacters.
+ * NO_REGEX: pattern matching with character set detection is supported,
+ *           but without metacharacters.
  */
+#undef HAVE_POSIX_REGCOMP_CS
+#undef HAVE_V8_REGCOMP_CS
 #undef HAVE_POSIX_REGCOMP
 #undef HAVE_PCRE
 #undef HAVE_RE_COMP
@@ -201,6 +247,26 @@
 #undef HAVE_V8_REGCOMP
 #undef NO_REGEX
 #undef HAVE_REGEXEC2
+
+/*
+ * Does regular expression library detect character set?
+ */
+#undef CS_REGEX
+
+/*
+ * Define MSB_ENABLE if you want to enable a MSB of non ASCII characters.
+ * It will be help if your library has not ability to detect a character set.
+ * If it has ability, this should be 0.  If your system was not worked well,
+ * try to change following into 0 by hand.
+ */
+#undef MSB_ENABLE
+
+/*
+ * Define SJIS0213 or UJIS0213 if you want to enable a JIS X 0213:2000
+ * mapping of SJIS and UJIS encoding.
+ */
+#undef SJIS0213
+#undef UJIS0213
 
 /* Define HAVE_VOID if your compiler supports the "void" type. */
 #undef HAVE_VOID
Index: less/defines.h.top
diff -u less/defines.h.top:1.1.1.10 less/defines.h.top:1.27
--- less/defines.h.top:1.1.1.10	Sun Oct 29 02:03:37 2000
+++ less/defines.h.top	Sun Oct 29 02:17:18 2000
@@ -158,6 +158,46 @@
 #define	HAVE_DUP	1
 
 /*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"japanese-iso7"
+
+/*
  * Sizes of various buffers.
  */
 #define	CMDBUF_SIZE	512	/* Buffer for multichar commands */
Index: less/defines.o2
diff -u less/defines.o2:1.1.1.6 less/defines.o2:1.16
--- less/defines.o2:1.1.1.6	Sun Oct 29 02:19:18 2000
+++ less/defines.o2	Tue Oct 31 04:30:39 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /* OS/2 definition file for less.  */
@@ -156,6 +162,46 @@
 #define	HAVE_DUP	1
 
 /*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"japanese-iso7"
+
+/*
  * Sizes of various buffers.
  */
 #define	CMDBUF_SIZE	512	/* Buffer for multichar commands */
@@ -179,19 +225,38 @@
 
 /*
  * Regular expression library.
+ * Some are extended to detect character set.
  * Define exactly one of the following to be 1:
+ * HAVE_POSIX_REGCOMP_CS: extended POSIX regcomp() and regex.h
+ * HAVE_V8_REGCOMP_CS: extended Henry Spencer V8 regcomp() and regexp.h
  * HAVE_POSIX_REGCOMP: POSIX regcomp() and regex.h
  * HAVE_RE_COMP: BSD re_comp()
  * HAVE_REGCMP: System V regcmp()
  * HAVE_V8_REGCOMP: Henry Spencer V8 regcomp() and regexp.h
- * NO_REGEX: pattern matching is supported, but without metacharacters.
+ * NO_REGEX: pattern matching with character set detection is supported,
+ *           but without metacharacters.
  */
+/* #undef HAVE_POSIX_REGCOMP_CS */
+/* #undef HAVE_V8_REGCOMP_CS */
 /* #undef HAVE_POSIX_REGCOMP */
 /* #undef HAVE_RE_COMP */
 /* #undef HAVE_REGCMP */
 #define HAVE_V8_REGCOMP 1
 /* #undef NO_REGEX */
 #define HAVE_REGEXEC2 1
+
+/*
+ * Does regular expression library detect character set?
+ */
+#define CS_REGEX 0
+
+/*
+ * Define MSB_ENABLE if you want to enable a MSB of non ASCII characters.
+ * It will be help if your library has not ability to detect a character set.
+ * If it has ability, this should be 0.  If your system was not worked well,
+ * try to change following into 0 by hand.
+ */
+#define MSB_ENABLE 1
 
 /* Define HAVE_VOID if your compiler supports the "void" type. */
 #define HAVE_VOID 1
Index: less/defines.o9
diff -u less/defines.o9:1.1.1.8 less/defines.o9:1.18
--- less/defines.o9:1.1.1.8	Sun Oct 29 02:19:18 2000
+++ less/defines.o9	Tue Oct 31 04:30:39 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /* OS/9 definition file for less.  */
@@ -169,6 +175,46 @@
 #define	HAVE_DUP 0
 
 /*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"japanese-iso7"
+
+/*
  * Sizes of various buffers.
  */
 #define	CMDBUF_SIZE	512	/* Buffer for multichar commands */
@@ -196,19 +242,38 @@
 
 /*
  * Regular expression library.
+ * Some are extended to detect character set.
  * Define exactly one of the following to be 1:
+ * HAVE_POSIX_REGCOMP_CS: extended POSIX regcomp() and regex.h
+ * HAVE_V8_REGCOMP_CS: extended Henry Spencer V8 regcomp() and regexp.h
  * HAVE_POSIX_REGCOMP: POSIX regcomp() and regex.h
  * HAVE_RE_COMP: BSD re_comp()
  * HAVE_REGCMP: System V regcmp()
  * HAVE_V8_REGCOMP: Henry Spencer V8 regcomp() and regexp.h
- * NO_REGEX: pattern matching is supported, but without metacharacters.
+ * NO_REGEX: pattern matching with character set detection is supported,
+ *           but without metacharacters.
  */
+#define HAVE_POSIX_REGCOMP_CS 0
+#define HAVE_V8_REGCOMP_CS 0
 #define HAVE_POSIX_REGCOMP 0
 #define HAVE_RE_COMP 0
 #define HAVE_REGCMP 0
 #define HAVE_V8_REGCOMP 1
 #define NO_REGEX 0
 #define HAVE_REGEXEC2 1
+
+/*
+ * Does regular expression library detect character set?
+ */
+#define CS_REGEX 0
+
+/*
+ * Define MSB_ENABLE if you want to enable a MSB of non ASCII characters.
+ * It will be help if your library has not ability to detect a character set.
+ * If it has ability, this should be 0.  If your system was not worked well,
+ * try to change following into 0 by hand.
+ */
+#define MSB_ENABLE 1
 
 /* Define HAVE_VOID if your compiler supports the "void" type. */
 #define HAVE_VOID 1
Index: less/defines.wn
diff -u less/defines.wn:1.1.1.6 less/defines.wn:1.16
--- less/defines.wn:1.1.1.6	Sun Oct 29 02:19:18 2000
+++ less/defines.wn	Tue Oct 31 04:30:39 2000
@@ -7,6 +7,12 @@
  * For more information about less, or for information on how to 
  * contact the author, see the README file.
  */
+/*
+ * Copyright (c) 1997-2000  Kazushi (Jam) Marukawa
+ * All rights of japanized routines reserved.
+ *
+ * You may distribute under the terms of the Less License.
+ */
 
 
 /* Windows definition file for less.  */
@@ -157,6 +163,46 @@
 #define	HAVE_DUP	1
 
 /*
+ * COMPRESS is 1 if you want to read comressed file.
+ */
+#define	COMPRESS	1
+
+/*
+ * ISO is 1 if you want to read code which contain many character sets
+ * by using iso 2022 code extension techniques.
+ */
+#define	ISO		1
+
+/*
+ * JAPANESE is 1 if you want to read several KANJI code.
+ */
+#define	JAPANESE	1
+#if JAPANESE && !ISO
+# define ISO 1
+#endif
+
+/*
+ * DEFCHARSET is name of the default character set.
+ * This used as LESSCHARSET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSCHARSET environment variable
+ */
+#define	DEFCHARSET	"iso8"
+
+/*
+ * DEFPLANESET is name of the default plane set of iso 2022 extension.
+ * This used as LESSPLANESET envrionment variable if user did not define it.
+ * The value of this must equal one of the available value which can use as
+ * LESSPLANESET environment variable or any escape sequence for setting up.
+ */
+#define	DEFPLANESET	"ctext"
+
+/*
+ * DEFKEYCHARSET is name of the default character set for keyboard input.
+ */
+#define	DEFKEYCHARSET	"sjis-iso7"
+
+/*
  * Sizes of various buffers.
  */
 #define	CMDBUF_SIZE	512	/* Buffer for multichar commands */
@@ -180,19 +226,38 @@
 
 /*
  * Regular expression library.
+ * Some are extended to detect character set.
  * Define exactly one of the following to be 1:
+ * HAVE_POSIX_REGCOMP_CS: extended POSIX regcomp() and regex.h
+ * HAVE_V8_REGCOMP_CS: extended Henry Spencer V8 regcomp() and regexp.h
  * HAVE_POSIX_REGCOMP: POSIX regcomp() and regex.h
  * HAVE_RE_COMP: BSD re_comp()
  * HAVE_REGCMP: System V regcmp()
  * HAVE_V8_REGCOMP: Henry Spencer V8 regcomp() and regexp.h
- * NO_REGEX: pattern matching is supported, but without metacharacters.
+ * NO_REGEX: pattern matching with character set detection is supported,
+ *           but without metacharacters.
  */
+/* #undef HAVE_POSIX_REGCOMP_CS */
+/* #undef HAVE_V8_REGCOMP_CS */
 /* #undef HAVE_POSIX_REGCOMP */
 /* #undef HAVE_RE_COMP */
 /* #undef HAVE_REGCMP */
 #define HAVE_V8_REGCOMP 1
 /* #undef NO_REGEX */
 #define HAVE_REGEXEC2 1
+
+/*
+ * Does regular expression library detect character set?
+ */
+#define CS_REGEX 0
+
+/*
+ * Define MSB_ENABLE if you want to enable a MSB of non ASCII characters.
+ * It will be help if your library has not ability to detect a character set.
+ * If it has ability, this should be 0.  If your system was not worked well,
+ * try to change following into 0 by hand.
+ */
+#define MSB_ENABLE 1
 
 /* Define HAVE_VOID if your compiler supports the "void" type. */
 #define HAVE_VOID 1
Index: less/edit.c
diff -u less/edit.c:1.1.1.15 less/edit.c:1.26
--- less/edit.c:1.1.1.15	Sun Oct 29 02:03:32 2000
+++ less/edit.c	Sun Oct 29 02:17:18 2000
@@ -350,6 +350,9 @@
 	curr_altpipe = alt_pipe;
 	set_open(curr_ifile); /* File has been opened */
 	get_pos(curr_ifile, &initial_scrpos);
+#if ISO
+	init_multi(get_mulbuf(curr_ifile));
+#endif
 	new_file = TRUE;
 	ch_init(f, chflags);
 
@@ -381,7 +384,7 @@
 #if HILITE_SEARCH
 		clr_hilite();
 #endif
-		cmd_addhist(ml_examine, filename);
+		cmd_addhist(ml_examine, filename, NULL);
 		if (no_display && errmsgs > 0)
 		{
 			/*
